using Exferia_Aplicacion.General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_Maestros.General;
using Exferia_Maestros._0_Modelos;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_EntityFramework;

namespace Exferia_Maestros._3_Vistas.Listados
{
    public class ABS_Listado_MAE_Ubicaciones : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_MAE_Ubicaciones()
        {
            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            //id
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.id), "id", Enumerados.G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, true, false, "", null));

            //codigo
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.codigo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.codigo), "Código", Enumerados.G_ENUM_TIPOSDATOS.LONG_TEXT, false, 90, true, true, true, false, "", null));

            //descripcion
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.descripcion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.descripcion), "Descripción", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 150, true, true, true, false, "", null));

            //Empresa
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_EMPRESA = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.idEmpresa), nameof(GEN_Empresas), nameof(GEN_Empresas.id), nameof(GEN_Empresas.codigo), nameof(GEN_Empresas.descripcion), nameof(GEN_Empresas.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.Empresa), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.Empresa), "Empresa", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 90, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_EMPRESA));

            //Almacen
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_ALMACEN = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.idAlmacen), nameof(GEN_Almacenes), nameof(GEN_Almacenes.id), nameof(GEN_Almacenes.codigo), nameof(GEN_Almacenes.descripcion), nameof(GEN_Almacenes.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.Almacen), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.Almacen), "Almacen", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 90, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_ALMACEN));

            //UbicacionPerfil
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_UBICACIONPERFIL = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.idUbicacionPerfil), nameof(MAE_UbicacionesPerfiles), nameof(MAE_UbicacionesPerfiles.id), nameof(MAE_UbicacionesPerfiles.codigo), nameof(MAE_UbicacionesPerfiles.descripcion), nameof(MAE_UbicacionesPerfiles.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.UbicacionPerfil), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.UbicacionPerfil), "Ubicación Perfil", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 90, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_UBICACIONPERFIL));

            //tipoFuncion
            INTERNO_Filtro_Opciones_Modelo mdl_INTERNO_Filtro_Opciones_Modelo_TIPOFUNCION = new INTERNO_Filtro_Opciones_Modelo();
            mdl_INTERNO_Filtro_Opciones_Modelo_TIPOFUNCION.MULTISELECCION = true;
            mdl_INTERNO_Filtro_Opciones_Modelo_TIPOFUNCION.LISTADO = new List<INTERNO_Filtro_Opciones_Listado_Modelo>();
            mdl_INTERNO_Filtro_Opciones_Modelo_TIPOFUNCION.LISTADO.Add(new INTERNO_Filtro_Opciones_Listado_Modelo(Variables.G_MDL_TIPOFUNCION_PICKING.Descripcion, Variables.G_MDL_TIPOFUNCION_PICKING.Descripcion));
            mdl_INTERNO_Filtro_Opciones_Modelo_TIPOFUNCION.LISTADO.Add(new INTERNO_Filtro_Opciones_Listado_Modelo(Variables.G_MDL_TIPOFUNCION_RESERVA.Descripcion, Variables.G_MDL_TIPOFUNCION_RESERVA.Descripcion));
            mdl_INTERNO_Filtro_Opciones_Modelo_TIPOFUNCION.LISTADO.Add(new INTERNO_Filtro_Opciones_Listado_Modelo(Variables.G_MDL_TIPOFUNCION_PLAYAPICKING.Descripcion, Variables.G_MDL_TIPOFUNCION_PLAYAPICKING.Descripcion));
            mdl_INTERNO_Filtro_Opciones_Modelo_TIPOFUNCION.LISTADO.Add(new INTERNO_Filtro_Opciones_Listado_Modelo(Variables.G_MDL_TIPOFUNCION_MUELLEENTRADA.Descripcion, Variables.G_MDL_TIPOFUNCION_MUELLEENTRADA.Descripcion));
            mdl_INTERNO_Filtro_Opciones_Modelo_TIPOFUNCION.TIPO = 1;
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.TipoFuncion_Texto), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.TipoFuncion_Texto), "Tipo de función", Enumerados.G_ENUM_TIPOSDATOS.OPCIONES, false, 120, true, false, true, false, "", null, false, mdl_INTERNO_Filtro_Opciones_Modelo_TIPOFUNCION));

            //pasillo
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.pasillo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.pasillo), "Pasillo", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 90, true, false, false, false, "", null));

            //hueco
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.hueco), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.hueco), "Hueco", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 90, true, false, false, false, "", null));

            //altura
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.altura), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.altura), "Altura", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 90, true, false, false, false, "", null));

            //medida_Alto
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.medida_Alto), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.medida_Alto), "Medida alto", Enumerados.G_ENUM_TIPOSDATOS.DECIMAL, false, 50, true, false, false, false, "", null));

            //medida_Ancho
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.medida_Ancho), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.medida_Ancho), "Medida ancho", Enumerados.G_ENUM_TIPOSDATOS.DECIMAL, false, 50, true, false, false, false, "", null));

            //medida_Largo
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.medida_Largo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.medida_Largo), "Medida largo", Enumerados.G_ENUM_TIPOSDATOS.DECIMAL, false, 50, true, false, false, false, "", null));

            //huecos_Alto
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.huecos_Alto), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.huecos_Alto), "Huecos Alto", Enumerados.G_ENUM_TIPOSDATOS.INT, false, 50, true, false, false, false, "", null));

            //huecos_Ancho
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.huecos_Ancho), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.huecos_Ancho), "Huecos Ancho", Enumerados.G_ENUM_TIPOSDATOS.INT, false, 50, true, false, false, false, "", null));

            //huecos_Largo
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.huecos_Largo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.huecos_Largo), "Huecos Largo", Enumerados.G_ENUM_TIPOSDATOS.INT, false, 50, true, false, false, false, "", null));

            //pesoMaximo
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.pesoMaximo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.pesoMaximo), "Peso Máximo", Enumerados.G_ENUM_TIPOSDATOS.DECIMAL, false, 50, true, false, false, false, "", null));

            //secuencia
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.secuencia), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.secuencia), "Secuencia", Enumerados.G_ENUM_TIPOSDATOS.INT, false, 50, true, false, false, false, "", null));
           

        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_MAE_UBICACION);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_MAE_UBICACION;
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_MAE_Ubicaciones_Listado_Modelo.codigo);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
